> For the complete documentation index, see [llms.txt](https://docs.wisej.com/ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.wisej.com/ai/components/api/smartadapter/wisej.ai.smartadapter.workswithattribute.md).

# SmartAdapter.WorksWithAttribute

Namespace: **Wisej.AI**

Assembly: **Wisej.AI** (3.5.0.0)

Represents an attribute that specifies the compatibility of a [SmartAdapter](/ai/components/api/smartadapter.md) with a [SmartEndpoint](/ai/components/api/smartendpoint.md).

{% tabs %}
{% tab title="C#" %}

```csharp
public class WorksWithAttribute : Attribute
```

{% endtab %}

{% tab title="VB.NET" %}

```visual-basic
Public Class WorksWithAttribute
    Inherits Attribute
```

{% endtab %}
{% endtabs %}

This attribute is used to indicate that a [SmartAdapter](/ai/components/api/smartadapter.md) works with a specific [SmartEndpoint](/ai/components/api/smartendpoint.md). It can be applied multiple times to specify compatibility with different [SmartEndpoint](/ai/components/api/smartendpoint.md) types.

## Constructors

### ![](/files/ptrKjmmRoQB76pvrIqh0) WorksWithAttribute(type, allowed)

Initializes a new instance of the [WorksWithAttribute](/ai/components/api/smartadapter/wisej.ai.smartadapter.workswithattribute.md) class with the specified type and allowed status.

| Name        | Type                                                            | Description                                                                                                     |
| ----------- | --------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------- |
| **type**    | [Type](https://docs.microsoft.com/dotnet/api/system.type)       | The type that the class works with. Must be a subclass of [SmartEndpoint](/ai/components/api/smartendpoint.md). |
| **allowed** | [Boolean](https://docs.microsoft.com/dotnet/api/system.boolean) | Indicates whether the type is allowed. Default is `true`.                                                       |

**Throws:**

* [ArgumentNullException](https://docs.microsoft.com/dotnet/api/system.argumentnullexception)\
  Thrown when the *type* is `null`.
* [ArgumentException](https://docs.microsoft.com/dotnet/api/system.argumentexception)\
  Thrown when the *type* is not a subclass of [SmartEndpoint](/ai/components/api/smartendpoint.md).

### ![](/files/ptrKjmmRoQB76pvrIqh0) WorksWithAttribute(type, allowed)

Initializes a new instance of the [WorksWithAttribute](/ai/components/api/smartadapter/wisej.ai.smartadapter.workswithattribute.md) class with the specified type name and allowed status.

| Name        | Type                                                            | Description                                                                                                                 |
| ----------- | --------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------- |
| **type**    | [String](https://docs.microsoft.com/dotnet/api/system.string)   | The name of the type that the class works with. Must be a subclass of [SmartEndpoint](/ai/components/api/smartendpoint.md). |
| **allowed** | [Boolean](https://docs.microsoft.com/dotnet/api/system.boolean) | Indicates whether the type is allowed. Default is `true`.                                                                   |

**Throws:**

* [ArgumentNullException](https://docs.microsoft.com/dotnet/api/system.argumentnullexception)\
  Thrown when the *type* is `null`.
* [ArgumentException](https://docs.microsoft.com/dotnet/api/system.argumentexception)\
  Thrown when the *type* is not a subclass of [SmartEndpoint](/ai/components/api/smartendpoint.md).

## Properties

### ![](/files/ptrKjmmRoQB76pvrIqh0) Allowed

[Boolean](https://docs.microsoft.com/dotnet/api/system.boolean): Gets a value indicating whether the [SmartEndpoint](/ai/components/api/smartendpoint.md) is allowed.

### ![](/files/ptrKjmmRoQB76pvrIqh0) Type

[Type](https://docs.microsoft.com/dotnet/api/system.type): Gets the [SmartEndpoint](/ai/components/api/smartendpoint.md) that the attribute allows or disallows.

### ![](/files/ptrKjmmRoQB76pvrIqh0) TypeName

[String](https://docs.microsoft.com/dotnet/api/system.string): Gets the type name of the [SmartEndpoint](/ai/components/api/smartendpoint.md) that the attribute allows or disallows.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.wisej.com/ai/components/api/smartadapter/wisej.ai.smartadapter.workswithattribute.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
